/*
	To compile:
	dmd dwtest dwindows win winutil gdi32.lib
	
	To compile without a console:
	dmd dwtest dwindows win winutil gdi32.lib "-L/EXET:NT /SU:WINDOWS"
*/


import dwindows;


HINSTANCE appInstance;


class HelloWindow: Window
{
	const char[] CLASSNAME = "HelloWindow";
	const int ID_BTN = 34;
	
	Button btn;
	
	
	override LRESULT windowProc(UINT msg, WPARAM wparam, LPARAM lparam)
	{
		switch(msg)
		{
			case WM_COMMAND:
				switch(cast(short)wparam)
				{
					case ID_BTN:
						MessageBox(hwnd(), "Hello Window!", "Hi!", MB_ICONINFORMATION);
						break;
					
					default: ;
				}
				break;
			
			case WM_CLOSE:
				destroy();
				break;
			
			case WM_CREATE:
				with(btn = new Button)
				{
					create(0, "Click me!", WS_CHILD | WS_VISIBLE, 50, 50, 80, 26, this.hwnd(), ID_BTN);
					font(cast(HFONT)GetStockObject(DEFAULT_GUI_FONT), true);
				}
				break;
			
			case WM_DESTROY:
				PostQuitMessage(0);
				break;
			
			default:
				return super.windowProc(msg, wparam, lparam);
		}
		return 0;
	}
	
	
	//make the wndclass
	static void register()
	{
		WNDCLASSEX wce;
		wce.lpszClassName = CLASSNAME;
		wce.hInstance = appInstance;
		registerClass(&wce, WndClassFlags.NONE);
	}
}


int main()
{
	appInstance = GetModuleHandle(null);
	
	HelloWindow.register();
	HelloWindow hwin = new HelloWindow;
	hwin.create(0, HelloWindow.CLASSNAME, "Hello Window Title", WS_VISIBLE | WS_OVERLAPPEDWINDOW, 0, 0, 300, 260, null, null, appInstance);
	
	MSG msg;
	while(GetMessage(&msg, null, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return cast(int)msg.wParam;
}

